/*******************************************************************************
 * Copyright 2008 Seapine Software, Inc. All rights reserved.
 * 
 * IMPORTANT:  This Software is supplied to you by Seapine Software, Inc. (Seapine)
 * in consideration of your agreement to the following terms, and your use, installation,
 * modification or redistribution of this Software constitutes acceptance of these terms.
 * If you do not agree with these terms, please do not use, install, modify or redistribute
 * this Software.
 * 
 * In consideration of your agreement to abide by the following terms, and subject to these
 * terms, Seapine grants you a personal, non-exclusive license, under Seapine copyrights in
 * this original Seapine software (the Software), to use, reproduce, modify and redistribute
 * the Software, with or without modifications, in source and/or binary forms; provided that
 * if you redistribute the Software in its entirety and without modifications, you must retain
 * this notice and the following text and disclaimers in all such redistributions of the Software.
 * Neither the name, trademarks, service marks or logos of Seapine, Inc. may be used to endorse
 * or promote products derived from the Software without specific prior written permission from
 * Seapine.  Except as expressly stated in this notice, no other rights or licenses, express or
 * implied, are granted by Seapine herein, including but not limited to any patent rights that
 * may be infringed by your derivative works or by other works in which the Software may be
 * incorporated.
 * 
 * The Software is provided by Seapine on an "AS IS" basis.  SEAPINE MAKES NO WARRANTIES,
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND
 * OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS. 
 * 
 * IN NO EVENT SHALL SEAPINE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
 * REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE SOFTWARE, HOWEVER CAUSED AND WHETHER
 * UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
 * IF SEAPINE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/


namespace MSProjectSSCMAddin
{
    using System;
    using Microsoft.Office.Core;
    using Microsoft.Office.Interop.MSProject;
    using Extensibility;
    using stdole;
    using System.IO;
    using System.Reflection;
    using System.Runtime.InteropServices;
    using System.Windows.Forms;
	#region Read me for Add-in installation and setup information.
	// When run, the Add-in wizard prepared the registry for the Add-in.
	// At a later time, if the Add-in becomes unavailable for reasons such as:
	//   1) You moved this project to a computer other than which is was originally created on.
	//   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
	//   3) Registry corruption.
	// you will need to re-register the Add-in by building the MSProjectSSCMAddinSetup project, 
	// right click the project in the Solution Explorer, then choose install.
	#endregion
	
	/// <summary>
	///   The object for implementing an Add-in.
	/// </summary>
	/// <seealso class='IDTExtensibility2' />
	[GuidAttribute("55F85DCE-36AD-4F9A-8B5B-F38B1652FEEB"), ProgId("MSProjectSSCMAddin.Connect")]
	public class Connect : Object, Extensibility.IDTExtensibility2
    {
        /// <summary>
        ///		Implements the constructor for the Add-in object.
        ///		Place your initialization code within this method.
        /// </summary>
        /// 


        private CommandBarButton SCMRepoBrowButton;
        private CommandBarButton SCMConnectButton;
        public static string AppPath = System.Windows.Forms.Application.StartupPath.ToString();
        public sscapi sscm = new sscapi();
        public SCMConfig sConfig = new SCMConfig();
        public SCMConfig mSCMConfig = new SCMConfig();

        public string OutMsg;


        public Connect()
        {
        }

        /// <summary>
        ///      Implements the OnConnection method of the IDTExtensibility2 interface.
        ///      Receives notification that the Add-in is being loaded.
        /// </summary>
        /// <param term='application'>
        ///      Root object of the host application.
        /// </param>
        /// <param term='connectMode'>
        ///      Describes how the Add-in is being loaded.
        /// </param>
        /// <param term='addInInst'>
        ///      Object representing this Add-in.
        /// </param>
        /// <seealso class='IDTExtensibility2' />
        public void OnConnection(object application, Extensibility.ext_ConnectMode connectMode, object addInInst, ref System.Array custom)
        {
            applicationObject = application;
            addInInstance = addInInst;
            if (connectMode != Extensibility.ext_ConnectMode.ext_cm_Startup)
            {
                OnStartupComplete(ref custom);
            }
        }

        /// <summary>
        ///     Implements the OnDisconnection method of the IDTExtensibility2 interface.
        ///     Receives notification that the Add-in is being unloaded.
        /// </summary>
        /// <param term='disconnectMode'>
        ///      Describes how the Add-in is being unloaded.
        /// </param>
        /// <param term='custom'>
        ///      Array of parameters that are host application specific.
        /// </param>
        /// <seealso class='IDTExtensibility2' />
        public void OnDisconnection(Extensibility.ext_DisconnectMode disconnectMode, ref System.Array custom)
        {
            if (disconnectMode != Extensibility.ext_DisconnectMode.ext_dm_HostShutdown)
            {
                OnBeginShutdown(ref custom);
            }
            applicationObject = null;
        }

        /// <summary>
        ///      Implements the OnAddInsUpdate method of the IDTExtensibility2 interface.
        ///      Receives notification that the collection of Add-ins has changed.
        /// </summary>
        /// <param term='custom'>
        ///      Array of parameters that are host application specific.
        /// </param>
        /// <seealso class='IDTExtensibility2' />
        public void OnAddInsUpdate(ref System.Array custom)
        {
        }

        /// <summary>
        ///      Implements the OnStartupComplete method of the IDTExtensibility2 interface.
        ///      Receives notification that the host application has completed loading.
        /// </summary>
        /// <param term='custom'>
        ///      Array of parameters that are host application specific.
        /// </param>
        /// <seealso class='IDTExtensibility2' />
        public void OnStartupComplete(ref System.Array custom)
        {
            CommandBars oCommandBars;
        //    CommandBar oStandardBar;
            CommandBar oSurroundSCMBar;

            try
            {
                oCommandBars = (CommandBars)applicationObject.GetType().InvokeMember("CommandBars", BindingFlags.GetProperty, null, applicationObject, null);
            }
            catch (Exception)
            {
                // Outlook has the CommandBars collection on the Explorer object.
                object oActiveExplorer;
                oActiveExplorer = applicationObject.GetType().InvokeMember("ActiveExplorer", BindingFlags.GetProperty, null, applicationObject, null);
                oCommandBars = (CommandBars)oActiveExplorer.GetType().InvokeMember("CommandBars", BindingFlags.GetProperty, null, oActiveExplorer, null);
            }
            try
            {
                object omissing = System.Reflection.Missing.Value;
                oSurroundSCMBar = oCommandBars.Add("Surround SCM", omissing, omissing, omissing);
            }
            catch
            {
            }
            // Set up a custom button on the "Standard" commandbar.
            try
            {
                oSurroundSCMBar = oCommandBars["Surround SCM"];
            }
            catch (Exception)
            {
                // Access names its main toolbar Database.
                oSurroundSCMBar = oCommandBars["Database"];
            }

            // In case the button was not deleted, use the exiting one.
            try
            {
                SCMRepoBrowButton = (CommandBarButton)oSurroundSCMBar.Controls["Surround SCM Repository Browser"];
                SCMConnectButton = (CommandBarButton)oSurroundSCMBar.Controls["Surround SCM Database Connection"];
            }
            catch (Exception)
            {
                object omissing = System.Reflection.Missing.Value;

                SCMRepoBrowButton = (CommandBarButton)oSurroundSCMBar.Controls.Add(1, omissing, omissing, omissing, omissing);
                SCMRepoBrowButton.Caption = "Surround SCM Repository Browser";
                SCMRepoBrowButton.Picture = getServerImage();
                SCMRepoBrowButton.Style = MsoButtonStyle.msoButtonIcon;

                SCMConnectButton = (CommandBarButton)oSurroundSCMBar.Controls.Add(1, omissing, omissing, omissing, omissing);
                SCMConnectButton.Caption = "Surround SCM Database Connection";
                SCMConnectButton.Picture = getConnectImage();
                SCMConnectButton.Style = MsoButtonStyle.msoButtonIcon;
                oSurroundSCMBar.Visible = true;

            }

            SCMRepoBrowButton.Tag = "Surround SCM Repository Browser";
            SCMConnectButton.Tag = "Surround SCM Database Connection";

            // The OnAction property is optional but recommended. 
            //It should be set to the ProgID of the add-in, so that if
            //the add-in is not loaded when a user presses the button,
            //MSO loads the add-in automatically and then raises
            //the Click event for the add-in to handle. 
            SCMRepoBrowButton.OnAction = "!<MSProjectSSCMAddin.Connect>";
            SCMConnectButton.OnAction = "!<MSProjectSSCMAddin.Connect>";


            SCMRepoBrowButton.Visible = true;
            SCMRepoBrowButton.Click += new Microsoft.Office.Core._CommandBarButtonEvents_ClickEventHandler(this.SCMRepoBrowButton_Click);

            SCMConnectButton.Visible = true;
            SCMConnectButton.Click += new Microsoft.Office.Core._CommandBarButtonEvents_ClickEventHandler(this.SCMConnectButton_Click);

            object oName = applicationObject.GetType().InvokeMember("Name", BindingFlags.GetProperty, null, applicationObject, null);

            oSurroundSCMBar = null;
            oCommandBars = null;


        }

        /// <summary>
        ///      Implements the OnBeginShutdown method of the IDTExtensibility2 interface.
        ///      Receives notification that the host application is being unloaded.
        /// </summary>
        /// <param term='custom'>
        ///      Array of parameters that are host application specific.
        /// </param>
        /// <seealso class='IDTExtensibility2' />
        /// 
        private stdole.IPictureDisp getConnectImage()
        {
            stdole.IPictureDisp tempImage = null;
            try
            {

                System.Drawing.Bitmap newIcon = Properties.Resources.disconnect_32x32;
                ImageList newImageList = new ImageList();
                newImageList.Images.Add(newIcon);
                tempImage = ConvertImage.Convert(newImageList.Images[0]);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            return tempImage;
        }
        private stdole.IPictureDisp getServerImage()
        {
            stdole.IPictureDisp tempImage = null;
            try
            {
                System.Drawing.Bitmap newIcon = Properties.Resources.server_32x32;
                ImageList newImageList = new ImageList();
                newImageList.Images.Add(newIcon);
                tempImage = ConvertImage.Convert(newImageList.Images[0]);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            return tempImage;
        }

        sealed public class ConvertImage : System.Windows.Forms.AxHost
        {
            private ConvertImage()
                : base(null)
            {
            }
            public static stdole.IPictureDisp Convert(System.Drawing.Image image)
            {
                return (stdole.IPictureDisp)System.
                Windows.Forms.AxHost
                .GetIPictureDispFromPicture(image);

            }
        }
        public void OnBeginShutdown(ref System.Array custom)
        {

            object omissing = System.Reflection.Missing.Value;
            SCMRepoBrowButton.Delete(omissing);
            SCMRepoBrowButton = null;

            SCMConnectButton.Delete(omissing);
            SCMConnectButton = null;
        }
        private void SCMRepoBrowButton_Click(CommandBarButton cmdBarbutton, ref bool cancel)
        {
            Microsoft.Office.Interop.MSProject.Application myApp = (Microsoft.Office.Interop.MSProject.Application)applicationObject;
            
            Project myProject = myApp.ActiveProject;
            if (sConfig.Exists())
            {
                OutMsg = sscm.GetConnInfo();
                if (OutMsg.Equals(""))
                {
                    OutMsg = sscm.SetSCMSRV();
                    scmRepo aSCMREPO = new scmRepo(sscm, myProject, myApp);
                    aSCMREPO.Show();
                }
                else
                {
                    MessageBox.Show("There following error occured while reading the configuration file: \n" + OutMsg, "Surround SCM Add-in");
                }
            }
            else
            {
                frmSCMConnection aConnection = new frmSCMConnection(sscm,sConfig );
                aConnection.Show();
            }
        }

        private void SCMConnectButton_Click(CommandBarButton cmdBarbutton, ref bool cancel)
        {
            frmSCMConnection aConnection = new frmSCMConnection(sscm,sConfig);
            aConnection.Show();
        }
        private object applicationObject;
        private object addInInstance;
    }
}