/*******************************************************************************
 * Copyright 2008 Seapine Software, Inc. All rights reserved.
 * 
 * IMPORTANT:  This Software is supplied to you by Seapine Software, Inc. (Seapine)
 * in consideration of your agreement to the following terms, and your use, installation,
 * modification or redistribution of this Software constitutes acceptance of these terms.
 * If you do not agree with these terms, please do not use, install, modify or redistribute
 * this Software.
 * 
 * In consideration of your agreement to abide by the following terms, and subject to these
 * terms, Seapine grants you a personal, non-exclusive license, under Seapine copyrights in
 * this original Seapine software (the Software), to use, reproduce, modify and redistribute
 * the Software, with or without modifications, in source and/or binary forms; provided that
 * if you redistribute the Software in its entirety and without modifications, you must retain
 * this notice and the following text and disclaimers in all such redistributions of the Software.
 * Neither the name, trademarks, service marks or logos of Seapine, Inc. may be used to endorse
 * or promote products derived from the Software without specific prior written permission from
 * Seapine.  Except as expressly stated in this notice, no other rights or licenses, express or
 * implied, are granted by Seapine herein, including but not limited to any patent rights that
 * may be infringed by your derivative works or by other works in which the Software may be
 * incorporated.
 * 
 * The Software is provided by Seapine on an "AS IS" basis.  SEAPINE MAKES NO WARRANTIES,
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND
 * OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS. 
 * 
 * IN NO EVENT SHALL SEAPINE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
 * REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE SOFTWARE, HOWEVER CAUSED AND WHETHER
 * UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
 * IF SEAPINE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;
using Microsoft.Office.Interop.MSProject;
using System.Xml;

namespace MSProjectSSCMAddin
{
    public class sscapi
    {
        protected string sqlServer;
        protected string sqlUserName;
        protected string sqlPassword;
        protected string sqlDatabase;
        protected string scmSRV;

        protected string connString;
        //public method to set conenction string
        public void SetConnString()
        {
            connString = "server=" + sqlServer +";user id="+sqlUserName+";password="+sqlPassword+";initial catalog="+sqlDatabase+";" ;
        }
        //sets global variable from file
        public string SetSCMSRV()
        {
            string OutMsg = "";
            try
            {

                XmlDocument mDocument;
                XmlNode mCurrentNode;

                mDocument = new XmlDocument();
                mDocument.Load(Connect.AppPath + "\\SSCMConfig.xml");
                mCurrentNode = mDocument.DocumentElement;

                mCurrentNode = mCurrentNode.SelectSingleNode("//SCMSRVPORT");
                scmSRV = mCurrentNode.InnerText;

            }
            catch (System.Exception f)
            {
                OutMsg = f.Message;
            }
            return OutMsg;
        }
        //Reads config file and sets global vars
        public string GetConnInfo()
        {
            string OutMsg = "";
            try
            {

                XmlDocument mDocument;
                XmlNode mCurrentNode;

                mDocument = new XmlDocument();
                mDocument.Load(Connect.AppPath + "\\SSCMConfig.xml");
                mCurrentNode = mDocument.DocumentElement;

                mCurrentNode = mCurrentNode.SelectSingleNode("//SQLServerAddress");
                sqlServer = mCurrentNode.InnerText;

                mCurrentNode = mCurrentNode.SelectSingleNode("//SQLUserName");
                sqlUserName = mCurrentNode.InnerText;

                mCurrentNode = mCurrentNode.SelectSingleNode("//SQLPassword");
                sqlPassword = mCurrentNode.InnerText;


                mCurrentNode = mCurrentNode.SelectSingleNode("//SQLDatabase");
                sqlDatabase = mCurrentNode.InnerText;

            }
            catch (System.Exception f)
            {
                OutMsg = f.Message;
            }
            return OutMsg;

        }

        //Methods to either get values from global vars or set them
        //SQL Server
        public string getSQLSrv()
        {
            return (sqlServer);
        }
        public void setSQLSrv(string sqlSrv)
        {
            sqlServer = sqlSrv;
        }
        //Database
        public string getSQLDB()
        {
            return (sqlDatabase);
        }
        public void setSQLDB(string sqlDb)
        {
            sqlDatabase = sqlDb;
        }
        //UserName
        public string getSQLUserName()
        {

            return (sqlUserName);
        }
        public void setUserName(string sqlUName)
        {
            sqlUserName = sqlUName;
        }
        //Password
        public string getSQLUserPassword()
        {
            return (sqlPassword);
        }
        public void setSQLUserPassword(string sqlUPassword)
        {
            sqlPassword = sqlUPassword;
        }
        
        //-----Defining classes for each object that we will use
        //CBranch - Surround SCM branch object
        

        public partial class CBranch
        {

            private string ID;
            private string Name;
            private string Path;
            private string ParentID;
            private string Parent;
            private string Level;
            private string Mainline;
            private string MainlineID;

            /// <remarks/>
            ///
            public string GetID()
            {
                return this.ID;

            }
            public void SetID(string id)
            {
                this.ID = id;
            }

            public string GetName()
            {
                return this.Name;

            }
            public void SetName(string name)
            {
                this.Name = name;
            }

            public string GetPath()
            {
                return this.Path;

            }
            public void SetPath(string path)
            {
                this.Path = path;
            }

            public string GetParentID()
            {
                return this.ParentID;

            }
            public void SetParentID(string parentid)
            {
                this.ParentID = parentid;

            }

            public string GetParent()
            {
                return this.Parent;

            }
            public void SetParent(string parent)
            {
                this.Parent = parent;

            }
            public string GetLevel()
            {
                return this.Level;

            }
            public void SetLevel(string level)
            {
                this.Level = level;

            }
            public string GetMainlineID()
            {
                return this.MainlineID;

            }
            public void SetMainlineID(string mainlineid)
            {
                this.MainlineID = mainlineid;

            }

            public string GetMainline()
            {
                return this.Mainline;

            }
            public void SetMainline(string mainline)
            {
                this.Mainline = mainline;

            }
        }
        //-----CRepository - Surround SCM repository
        public partial class CRepository
        {

            private string ID;
            private string Name;
            private string Path;
            private string ParentID;
            private string Parent;
            private string Level;
            private string MainlineID;

            /// <remarks/>
            ///
            public string GetID()
            {
                return this.ID;

            }
            public void SetID(string id)
            {
                this.ID = id;
            }

            public string GetName()
            {
                return this.Name;

            }
            public void SetName(string name)
            {
                this.Name = name;
            }

            public string GetPath()
            {
                return this.Path;

            }
            public void SetPath(string path)
            {
                this.Path = path;
            }

            public string GetParentID()
            {
                return this.ParentID;

            }
            public void SetParentID(string parentid)
            {
                this.ParentID = parentid;

            }

            public string GetMainlineID()
            {
                return this.MainlineID;

            }
            public void SetMainlineID(string mainlineid)
            {
                this.MainlineID = mainlineid;

            }

            public string GetParent()
            {
                return this.Parent;

            }
            public void SetParent(string parent)
            {
                this.Parent = parent;

            }
            public string GetLevel()
            {
                return this.Level;

            }
            public void SetLevel(string level)
            {
                this.Level = level;

            }
        }

        //Method to get list of mainline branches
        public string[] GetMainlines()
        {
            string[] Mainlines = null;
            SqlConnection myConnection = new SqlConnection(connString);

            SqlDataAdapter ad = new SqlDataAdapter("SELECT MainlineName from Mainline", myConnection);
            DataSet ds = new DataSet();

            ad.Fill(ds, "Mainlines");

            int rowCount = ds.Tables[0].Rows.Count;
            Mainlines = new string[rowCount];
            for (int i = 0; i < rowCount; i++)
            {
                Mainlines[i] = ds.Tables[0].Rows[i][0].ToString();
            }
            return Mainlines;
          
        }
        //Method to get branches from a given mainline
        public CBranch[] GetBranchTreeforMainline(string mainline)
        {
            CBranch[] scmBranches = null;
            SqlConnection myConnection = new SqlConnection(connString);

            SqlDataAdapter ad = new SqlDataAdapter("SELECT BRANCH.MainlineID, BranchID, BranchName, ParentBranchID from BRANCH, MAINLINE WHERE MAINLINE.MainlineName = '"+ mainline +"' AND BRANCH.MainlineID = MAINLINE.MainlineID", myConnection);
            DataSet ds = new DataSet();

            ad.Fill(ds, "Branches");

            int rowCount = ds.Tables[0].Rows.Count;
            scmBranches = new CBranch[rowCount];
            //Build the CBranch array
            for (int i = 0; i < rowCount; i++)
            {
                scmBranches[i] = new CBranch();
                scmBranches[i].SetMainlineID(ds.Tables[0].Rows[i][0].ToString());
                scmBranches[i].SetMainline(mainline);
                scmBranches[i].SetID(ds.Tables[0].Rows[i][1].ToString());
                scmBranches[i].SetName(ds.Tables[0].Rows[i][2].ToString());
                scmBranches[i].SetParentID(ds.Tables[0].Rows[i][3].ToString());

            }
            //Build more info on the CBranch array - the info built below is used for creating the branch and repo trees
            for (int i = 0; i < scmBranches.Length; i++)
            {
                String branchPath = "";
                String fullBranchPath = "";
                String parentPath = "";
                int level = 1;
                String ParentID = scmBranches[i].GetParentID();
                while (ParentID != "")
                {
                    for (int j = 0; j < scmBranches.Length; j++)
                    {
                        if (scmBranches[j].GetID().Equals(ParentID))
                        {
                            parentPath = scmBranches[j].GetName();
                            if (level == 1)
                            {
                                scmBranches[i].SetParent(parentPath);
                            }
                            branchPath = parentPath + "/" + branchPath;
                            level++;
                            ParentID = scmBranches[j].GetParentID();
                        }

                    }
                }
                fullBranchPath = branchPath + scmBranches[i].GetName();
                scmBranches[i].SetPath(fullBranchPath);
                scmBranches[i].SetLevel(level.ToString());

            }



            return scmBranches;

        }
        //Method to get files for selected repo
        public string[] GetFilesForRepo(CRepository[] scmRepo, string nodePath)
        {
            string[] scmFiles = null;
            string repoID = "";
            string mainlineID = "";
            for (int i = 0; i < scmRepo.Length; i++)
            {
                if (scmRepo[i].GetPath() == nodePath)
                {
                    repoID = scmRepo[i].GetID();
                    mainlineID = scmRepo[i].GetMainlineID();
                }
            }
            SqlConnection myConnection = new SqlConnection(connString);
            SqlDataAdapter ad = new SqlDataAdapter("SELECT FileName FROM BRANCHFILE WHERE BranchRepoID = " + repoID + " and MainlineID = " + mainlineID, myConnection);
            DataSet ds = new DataSet();
            ad.Fill(ds, "Files");
            int rowCount = ds.Tables[0].Rows.Count;
            scmFiles = new string[rowCount];
            for (int i = 0; i < rowCount; i++)
            {
                scmFiles[i] = ds.Tables[0].Rows[i][0].ToString();
            }
            return scmFiles;
        }
        //Method to get repo tree for given branch
        public CRepository[] GetRepoTreeForBranch(string branchName, string mainlineName)
        {
            CRepository[] scmRepo = null;
            SqlConnection myConnection = new SqlConnection(connString);

            SqlDataAdapter ad = new SqlDataAdapter("SELECT branchrepoid, repositoryname, parentbranchrepoid, mainline.mainlineid from branchrepository, branch, mainline where mainline.mainlinename = '"+mainlineName+"'and mainline.mainlineid = branchrepository.mainlineid and branch.branchname = '" + branchName + "' and branch.branchid = branchrepository.branchid order by branchrepoid", myConnection);
            DataSet ds = new DataSet();

            ad.Fill(ds, "REPOSITORY");

            int rowCount = ds.Tables[0].Rows.Count;
            scmRepo = new CRepository[rowCount];
            //Build the repo array
            for (int i = 0; i < rowCount; i++)
            {
                scmRepo[i] = new CRepository();
                scmRepo[i].SetID(ds.Tables[0].Rows[i][0].ToString());
                scmRepo[i].SetName(ds.Tables[0].Rows[i][1].ToString());
                scmRepo[i].SetParentID(ds.Tables[0].Rows[i][2].ToString());
                scmRepo[i].SetMainlineID(ds.Tables[0].Rows[i][3].ToString());


            }
            //More info for repo array - info built below is used to build the repo tree
            for (int i = 0; i < scmRepo.Length; i++)
            {
                String repoPath = "";
                String fullRepoPath = "";
                String parentPath = "";
                int level = 1;
                String ParentID = scmRepo[i].GetParentID();
                while (ParentID != "")
                {
                    for (int j = 0; j < scmRepo.Length; j++)
                    {
                        if (scmRepo[j].GetID().Equals(ParentID))
                        {
                            parentPath = scmRepo[j].GetName();
                            if (level == 1)
                            {
                                scmRepo[i].SetParent(parentPath);
                            }
                            repoPath = parentPath + "/" + repoPath;
                            level++;
                            ParentID = scmRepo[j].GetParentID();
                        }

                    }
                }
                fullRepoPath = repoPath + scmRepo[i].GetName();
                scmRepo[i].SetPath(fullRepoPath);
                scmRepo[i].SetLevel(level.ToString());

            }
            return scmRepo;

        }
        //Method for populating a branch tree
        public TreeNode PopulateBranchTree(CBranch[] scmBranches)
        {
            //Start with the maineline
            TreeNode root = null;
            for (int i = 0; i < scmBranches.Length; i++)
            {
                if (scmBranches[i].GetLevel().Equals("1"))
                {
                    root = new TreeNode(scmBranches[i].GetName());
                }
            }
            //Now we will handle all other repos/nodes
            //Define the nodes we will be using
            TreeNode curNode = null;//node that we are currently on and test for children
            TreeNode addNode = null;//the node to add to the current node
            TreeNode testNode = null;//the node to test to reset the current node
            //Define strings that we will use when parsing out the repo path
            string branchPath = "";
            string branchToCheck = "";//String to use to check against testNode
            //Define ints
            int pos = 0;//position of "/" in repo path
            int nodeCnt = 0;//count of children in curNode
            for (int i = 0; i < scmBranches.Length; i++)
            {
                //We want all branches EXCEPT the root
                if (!(scmBranches[i].GetLevel().Equals("1")))
                {
                    curNode = root;
                    branchPath = scmBranches[i].GetPath();
                    //remove the root since that is already added
                    pos = branchPath.IndexOf("/");
                    branchPath = branchPath.Substring(pos + 1);
                    //if remaining path still has "/" we need to process further
                    while (branchPath.Contains("/"))
                    {
                        pos = branchPath.IndexOf("/");
                        branchToCheck = branchPath.Substring(0, pos);
                        branchPath = branchPath.Substring(pos + 1);
                        //we need to get the children of curNode and see which one we need to reset as curNode
                        nodeCnt = curNode.Nodes.Count;
                        for (int j = 0; j < nodeCnt; j++)
                        {
                            testNode = curNode.Nodes[j];
                            if (testNode.Text.Equals(branchToCheck))
                            {
                                curNode = testNode;
                                break;
                            }
                        }
                    }
                    addNode = new TreeNode(branchPath);
                    curNode.Nodes.Add(addNode);
                }
            }
            return root;

        }
        //Method to populate repo tree
        public TreeNode PopulateRepoTree(CRepository[] scmRepos )
        {
            //First we'll add the root (level 1)
            TreeNode root = null;
            for (int i = 0; i < scmRepos.Length; i++)
            {
                if (scmRepos[i].GetLevel().Equals("1"))
                {
                    root = new TreeNode(scmRepos[i].GetName());
                }
            }
            //Now we will handle all other repos/nodes
            //Define the nodes we will be using
            TreeNode curNode = null;//node that we are currently on and test for children
            TreeNode addNode = null;//the node to add to the current node
            TreeNode testNode = null;//the node to test to reset the current node
            //Define strings that we will use when parsing out the repo path
            string repoPath = "";
            string repoToCheck = "";//String to use to check against testNode
            //Define ints
            int pos = 0;//position of "/" in repo path
            int nodeCnt = 0;//count of children in curNode
            for (int i = 0; i < scmRepos.Length; i++)
            {
                //We want all repos EXCEPT the root
                if (!(scmRepos[i].GetLevel().Equals("1")))
                {
                    curNode = root;
                    repoPath = scmRepos[i].GetPath();
                    //remove the root since that is already added
                    pos = repoPath.IndexOf("/");
                    repoPath = repoPath.Substring(pos + 1);
                    //if remaining path still has "/" we need to process further
                    while (repoPath.Contains("/"))
                    {
                        pos = repoPath.IndexOf("/");
                        repoToCheck = repoPath.Substring(0, pos);
                        repoPath = repoPath.Substring(pos + 1);
                        //we need to get the children of curNode and see which one we need to reset as curNode
                        nodeCnt = curNode.Nodes.Count;
                        for (int j = 0; j < nodeCnt; j++)
                        {
                            testNode = curNode.Nodes[j];
                            if (testNode.Text.Equals(repoToCheck))
                            {
                                curNode = testNode;
                                break;
                            }
                        }
                    }
                    addNode = new TreeNode(repoPath);
                    curNode.Nodes.Add(addNode);
                }
            }
            return root;

        }
        public void createTask(Project passedProject, string scmFile, Microsoft.Office.Interop.MSProject.Application passedApp)
        {
            //If a task is selected, we'll add the hyperlink to it, otherwise we create a new task
            try
            {
                Task curTask = passedApp.ActiveCell.Task;
                Task task = null;
                if (curTask == null)
                {
                    task = passedProject.Tasks.Add("<Task Created By Surround SCM Add-in>", passedProject.Tasks.Count + 1);

                    task.Hyperlink = "sscm://" + scmSRV + "//" + scmFile;

                }
                else
                {   
                    curTask.Hyperlink = "sscm://"+scmSRV+"//" + scmFile;

                }


            }
            catch (System.Exception fcc)
            {
                MessageBox.Show("An error occurred while trying to insert the hyperlink." + fcc.Message,"MSProjectSSCMAddin");

            }



        }
    }
}
